<template>
  <div>
    <!-- 容器自动搬运策略配置 -->
    <p-card title="容器自动搬运策略配置">
      <span slot="extra">
        <p-button type="primary" style="margin-right: 10px" @click="showmodel()">添加</p-button>
      </span>
      <p-grid-form :label-col="{ span: 8 }" :span="8" :items="config.items" @submit="hanlderSubmit" />
      <p-table
        ref="table"
        row-key="id"
        bordered
        :doneBefore="doneBefore"
        :columns="config.columns"
        :remoteUrl="config.remoteUrl"
        :remoteParams="remoteParams"
        :rowSelectType="false"
        :data-source="data"
      >
        <template slot="isAvailable" slot-scope="text, record">
          <p-switch
            @change="(e) => onChange(e, text, record)"
            checked-children="开"
            un-checked-children="关"
            :default-checked="!!text"
          />
        </template>
        <template slot="operation" slot-scope="text, record">
          <!-- {{ text ? '禁用' : '启用' }} -->

          <a @click="showmodel(text)">策略管理</a>
          <a-divider type="vertical" />
          <a v-if="!text.isAvailable" @click="del(text)">删除</a>
          <span v-else>删除</span>
        </template>
      </p-table>
    </p-card>

    <p-modal
      title="详情"
      width="50%"
      :visible="visible"
      :confirm-loading="confirmLoading"
      @ok="handleOk"
      @cancel="handleCancel"
    >
      <p-grid-form :label-col="{ span: 8 }" ref="model" :span="8" :items="config.Modelitems" @submit="hanlderSubmit" />
    </p-modal>

    <p-modal
      title="错误信息"
      width="50%"
      :visible="visibleErrinfo"
      :confirm-loading="confirmLoading"
      @ok="visibleErrinfo = false"
      @cancel="handleCancel"
    >
      <div class="errinfo">
        {{ errinfo.errorInfo || '暂无' }}
      </div>
    </p-modal>
  </div>
</template>

<script>
import config from './config.js'
import { diffOption } from '@/views/kzyWMS/utils/index.js'
import { add, deletes, update } from './api'

export default {
  data() {
    return {
      config,
      data: [],
      type: true,
      remoteParams: {
        containerType: '',
        isAvailable: '',
        sourceArea: '',
        targetArea: '',
        taskType: '',
      },
      visible: false,
      visibleErrinfo: false,
      errinfo: {},
      confirmLoading: false,
    }
  },
  mounted() {
    // this.getinfo()
  },
  created() {
    diffOption(this.config.columns).then((res) => {
      this.config.columns = res
    })
  },
  methods: {
    onChange(e, text, record) {
      console.log(e, text, record)
      //   console.log(`p-switch to ${checked}`)
      this.changeisAvailable(e, record)
    },
    //修改是否可用
    async changeisAvailable(data, record) {
      //   console.log(data)
      if (data) {
        data = 1
      } else {
        data = 0
      }
      //   console.log(data, record)
      let datas = {
        ...record,
        isAvailable: data,
        id: record.id,
      }
      console.log(datas)
      let res = await update(datas)
      if (res.success) {
        this.$message.success(res.message)
        this.remoteParams = { ...this.remoteParams }
      } else {
        this.$exception(res)
      }
    },
    async showinfo(record) {
      console.log(record)
      let res = await deviceInfo({ deviceNo: record.deviceNo })
      console.log(res)
      if (res.success) {
        this.errinfo = res.data
        this.visibleErrinfo = true
      }
    },
    doneBefore(res) {
      res.data.list.forEach((item) => {
        // item.id = item.deviceNo
      })
      console.log(res)
      return res
    },
    hanlderSubmit(e, form) {
      e.preventDefault()
      form.validateFields((error, values) => {
        console.log(error, values, 'valuesvaluesvaluesvaluesvalues')
        // this.queryName = values.name
        // this.queryType = values.type
        // this.getlistCompanyByAuthId()
        if (!error) {
          this.remoteParams = { ...this.remoteParams, ...values }
        }
      })
    },
    handleOk(e) {
      this.$refs.model.form.validateFields(async (err, value) => {
        if (!err) {
          console.log(value)
          this.confirmLoading = true
          if (this.type) {
            let res = await update(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          } else {
            // console.log(value)
            delete value.id
            console.log(value)
            let res = await add(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          }

          this.confirmLoading = false
          //
        }
      })
    },
    handleCancel(e) {
      console.log('Clicked cancel button')
      this.visible = false
      this.visibleErrinfo = false
    },
    //点击弹出
    showmodel(data) {
      console.log(data)
      this.visible = true

      if (data) {
        this.$nextTick(() => {
          this.config.Modelitems.forEach((item) => {
            if (data.isAvailable) {
              item.disabled = true
              item.name == 'isAvailable' && (item.disabled = false)
            } else {
              item.disabled = false
            }
            // item.name == 'areaType' && (item.disabled = true)
          })
          this.$refs.model.form.setFieldsValue(data)
        })
        this.type = true
      } else {
        this.$nextTick(() => {
          this.$refs.model.form.resetFields()
        })
        this.type = false
      }
    },
    del(text) {
      let that = this
      console.log(text)
      this.$confirm({
        title: '确定是否要删除?',
        content: '',
        async onOk() {
          let res = await deletes({ id: text.id })
          if (res.success) {
            that.$message.success('删除成功')
            that.remoteParams = { ...that.remoteParams }
          } else {
            that.$exception(res)
          }
        },
        onCancel() {},
      })
    },
  },
}
</script>

<style lang="less" scoped>
.errinfo {
  padding: 10px;
  width: 100%;
  height: 200px;
  line-height: 50px;
  font-size: 20px;
  color: #fff;
  font-weight: bolder;
  text-align: center;
  background: rgb(145, 143, 144);
}
</style>
